#include <stdio.h>
#include <string.h>
#include <math.h>
#define n1     1000                  // max  width
#define n2     1000                  // max  height
#define red    1
#define blue   2
#define green  3
FILE    *fp,*fp1;
char    f1[60],f2[60];
short   h[539];                      //  bmp header
int     lh,lh1,lw,lw0,lw1;
unsigned char b0[n2][n1];            // origin map
unsigned char b[n2][n1];             // bit map, reversed
unsigned char w[n2][n1];             // temp bitmap for marked or ..
unsigned char w4[n2*4][n1*4];        // temp bitmap for display
unsigned char c[n1*4];               // work array, one line
                                     // 21~1, 25~2, 17+n*4;
unsigned char d[177+4][177+4];       // max_qr, add 2_white_edge
int hist[256], bp,wp,bw, ip=0;       // 150,50,100
int u,v,u1,u2,v1,v2,qr,nqr,ne,nn;    // k=qr*4+17;  nqr=k+4; ne=2,3,5.
double fx,fy,r,rx,ry,sx,sy,x,y,z,th,tx,ty, pi;
double ekx[5][5],eky[5][5],ex[5][5],ey[5][5], ad[25][2],xy[25][2];
int    ww[5][5],w9[25];
int ix1,ix2,ix3,ix4,iy1,iy2,iy3,iy4, q1x,q2x,q3x,q4x,q1y,q2y,q3y,q4y;
double a8[6];                        // matrix of transfer.
double xline[177],yline[177],zline[177];        // AXIS adjust. z~tmp
double zz[n1];                       // do AXIS adjust, ~tmp

double linear(x,y)           // linear insert
double x,y;
{
  int ix0,iy0,ix1,iy1,k;
  double wx,wy,zx,zy,z0,z1,z2,z3,z;
  iy0=y; iy1=iy0+1; wy=y-iy0;   zy=1.-wy;
  ix0=x; ix1=ix0+1; wx=x-ix0;   zx=1.-wx;
  z0=zx*zy; z1=wx*zy; z2=zx*wy; z3=wx*wy;
  z=b[iy0][ix0]*z0+b[iy0][ix1]*z1+b[iy1][ix0]*z2+b[iy1][ix1]*z3;
  return (z);
}

double center(zz,i1,i2)     // phsycal weight center, range in i1~i2-1
double *zz; int i1,i2;
{
  double s=0.,r=0.;  int i;
  for(i=i1;i<i2;i++){ s+=zz[i]*i; r+=zz[i]; } s/=r;
  return(s);
}

smooth_ne2(z,k,z1,z2)             // 1. calcul out bias, --> big_eye
double *z; int k,z1,z2;           // 2. linear insert
{                                 // 3. -bias
  int i,j;
  double r,s,t;
  r=0.; j=0; for(i=0;i<k;i++)if(z[i]!=0.){ j++; r+=z[i]; } r/=j;
  z[z1]=z[z2]=r;                  // fixed r, is bias
  for(i=1;i<k-1;i++)if(z[i]==0.){
    s=z[i+1]; j=0; if(s==0.){ s=z[i+2]; j=1; }
    if(j)z[i]=(z[i-1]*0.66667+s*0.33333); else z[i]=(z[i-1]+s)*0.5;
  }
  for(i=0;i<k;i++)z[i]-=r;
}

smooth_ne3(z,k,z1,z2)            // 1. bias= z(k/2)
double *z; int k,z1,z2;          // 2.
{                                // 3.
  int i,j;
  double r,s,t;
  r=z[z1]=z[z2]=z[k/2];            // fixed r, is bias
  for(i=1;i<k-1;i++)if(z[i]==0.){
    s=z[i+1]; j=0; if(s==0.){ s=z[i+2]; j=1; }
    if(j)z[i]=(z[i-1]*0.66667+s*0.33333); else z[i]=(z[i-1]+s)*0.5;
  }
  for(i=0;i<k;i++)z[i]-=r;
}

line2(ne,k)                   // workout Xline, Yline for tiny adjust
int ne,k;
{
  int i,j;
  double fx,fy,sx,sy,z,x0,y0,x1,y1,sxx,syy;
  int i1,i2,j1,j2;
  if(ne==2){  z=k-7;
    x0=ex[0][0]; y0=ey[0][0];
    sx=(ex[0][1]-x0)/z;     sy=(ey[1][0]-y0)/z;
//printf("x,yscale: %lf %lf\n",sx,sy);

    fx=(ey[0][1]-y0)/(ex[0][1]-x0);
    i1=x0+sx*4;   i2=ex[0][1]-sx*4;
    for(i=0;i<lw;i++){
      y1=sy*3; if(i<i1 || i>i2)y1=sy*2;
      z=fx*(i-x0)+y0+y1; v=z; w[v][i]=red;
      zz[i]=b[v][i];    // =linear(z,(double)i);
    }
    for(i=1;i<lw1;i++)if(zz[i]>0. && zz[i]<bw)
    if(zz[i]<zz[i-1] && zz[i]<zz[i+1])zz[i]=0;
//for(i=0;i<lw;i++)printf("%8.1lf",zz[i]); printf("\n");
    for(j=i=0;j<k;j+=2){
      while(zz[i]==0.)i++; i1=i;      while(zz[i]!=0.)i++; i2=i;
      xline[j]=center(zz,i1,i2);      if(j<6 || j>k-8)j+=4;
    }
    for(i=0;i<k;i++)zline[i]=(i-3)*sx+x0;
    for(i=0;i<k;i++)if(xline[i]!=0.)xline[i]=zline[i]-xline[i];
//for(i=0;i<k;i++)printf("%5.2lf",xline[i]); printf("\n");
    smooth_ne2(xline,k,3,k-4);
//for(i=0;i<k;i++)printf("%5.2lf",xline[i]); printf("\n");

    fy=(ex[1][0]-x0)/(ey[1][0]-y0);
    j1=y0+sy*4;   j2=ey[1][0]-sy*4;
    for(j=0;j<lh;j++){
      x1=sx*3; if(j<j1 || j>j2)x1=sx*2;
      z=fy*(j-y0)+x0+x1; u=z; w[j][u]=red;
      zz[j]=b[j][u];
    }
    for(i=1;i<lh1;i++)if(zz[i]>0. && zz[i]<bw)
    if(zz[i]<zz[i-1] && zz[i]<zz[i+1])zz[i]=0;
    for(j=i=0;j<k;j+=2){
      while(zz[i]==0.)i++; i1=i;      while(zz[i]!=0.)i++; i2=i;
      yline[j]=center(zz,i1,i2);      if(j<6 || j>k-8)j+=4;
    }
    for(i=0;i<k;i++)zline[i]=(i-3)*sy+y0;
    for(i=0;i<k;i++)if(yline[i]!=0.)yline[i]=zline[i]-yline[i];
//for(i=0;i<k;i++)printf("%5.2lf",yline[i]); printf("\n");
    smooth_ne2(yline,k,3,k-4);
//for(i=0;i<k;i++)printf("%5.2lf",yline[i]); printf("\n");
  }

  if(ne==3){  z=k-7;
    x0=ex[0][0]; y0=ey[0][0];
    sx=(ex[0][2]-x0)/z;    sy=(ey[2][0]-y0)/z;
//printf("x,yscale: %lf %lf\n",sx,sy);

    fx=(ey[0][2]-y0)/(ex[0][2]-x0);
    i1=x0+sx*4;   i2=ex[0][2]-sx*4;
    for(i=0;i<lw;i++){
      y1=sy*3; if(i<i1 || i>i2)y1=sy*2;
      z=fx*(i-x0)+y0+y1; v=z; w[v][i]=red;
      zz[i]=b[v][i];    // =linear(z,(double)i);
    }
    for(i=1;i<lw1;i++)if(zz[i]>0. && zz[i]<bw)
    if(zz[i]<zz[i-1] && zz[i]<zz[i+1])zz[i]=0;
    for(j=i=0;j<k;j+=2){
      while(zz[i]==0.)i++; i1=i;      while(zz[i]!=0.)i++; i2=i;
      xline[j]=center(zz,i1,i2);      if(j<6 || j>k-8)j+=4;
    }
    z=k/2-3;
    sxx=(ex[0][1]-x0)/z;
    for(i=0;i<=k/2;i++)zline[i]=(i-3)*sxx+x0;
    sxx=(ex[0][2]-ex[0][1])/z;
    for(i=k/2;i<k;i++)zline[i]=(i-k/2)*sxx+ex[0][1];
    for(i=0;i<k;i++)if(xline[i]!=0.)xline[i]=zline[i]-xline[i];
    smooth_ne3(xline,k,3,k-4);
//for(i=0;i<k;i++)printf("%5.2lf",xline[i]); printf("\n");

    fy=(ex[2][0]-x0)/(ey[2][0]-y0);
    j1=y0+sy*4;   j2=ey[2][0]-sy*4;
    for(j=0;j<lh;j++){
      x1=sx*3; if(j<j1 || j>j2)x1=sx*2;
      z=fy*(j-y0)+x0+x1; u=z; w[j][u]=red;
      zz[j]=b[j][u];
    }
    for(i=1;i<lh1;i++)if(zz[i]>0. && zz[i]<bw)
    if(zz[i]<zz[i-1] && zz[i]<zz[i+1])zz[i]=0;
    for(j=i=0;j<k;j+=2){
      while(zz[i]==0.)i++; i1=i;      while(zz[i]!=0.)i++; i2=i;
      yline[j]=center(zz,i1,i2);      if(j<6 || j>k-8)j+=4;
    }
    z=k/2-3;
    syy=(ey[1][0]-y0)/z;
    for(i=0;i<=k/2;i++)zline[i]=(i-3)*syy+y0;
    syy=(ey[2][0]-ey[1][0])/z;
    for(i=k/2;i<k;i++)zline[i]=(i-k/2)*syy+ey[1][0];
    for(i=0;i<k;i++)if(yline[i]!=0.)yline[i]=zline[i]-yline[i];
    smooth_ne3(yline,k,3,k-4);
//for(i=0;i<k;i++)printf("%5.2lf",yline[i]); printf("\n");
  }

  sprintf(f2,"zz%s",f1);  write_bmp(f2);
}

main(int ac, char **av)
{
  int i,j,k,l;
  int kx,ky;
  pi=atan(1.0)*4.;
  if(ac<2){
    printf("\n\t***** QRxx ******\n");
    printf("\n\t                        jiang 2012,3,29\n");
    printf("\n\tUsage:  qr8 *[.bmp]\n");
    exit(0);
  }
  strcpy(f2,av[1]); k=strlen(f2); for(i=0;i<k;i++)if(f2[i]=='.')break;
  if(i==k)strcat(f2,".bmp");
  sprintf(f1,"dir/b %s > qr3.tmp",f2); system(f1);

  fp1=fopen("qr3.tmp","r");
l10: ip++;
  fgets(f1,60,fp1); if(feof(fp1))goto l20;
  if(f1[0]=='z')goto l10;
  if(read_bmp())goto l10;              // b0_origin;  b1: 255- && lh1-
l11:                                   // turn_pic loop here
  wp=50; bp=150; bw=(wp+bp)/2;
  for(j=0;j<lh;j++)for(i=0;i<lw;i++) if(b[j][i]<=wp)b[j][i]=0;
  de_edge4();
  de_noise();
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)w[j][i]=b[j][i];
/* locate 4 corner in detail  */
  u1=v1=1;  u2=lw-2;  v2=lh-2;
  corner(u1,v1,&ix1,&iy1, 1, 1);   //0,0  ------>
  corner(u1,v2,&ix2,&iy2, 1,-1);   // |   ix1,iy1         ix3,iy3
  corner(u2,v1,&ix3,&iy3,-1, 1);   // |
  corner(u2,v2,&ix4,&iy4,-1,-1);   // v   ix2,iy2         ix4,iy4
//printf("\t%3d_%3d %3d_%3d %3d_%3d %3d_%3d\n",ix1,iy1,ix2,iy2,ix3,iy3,ix4,iy4);
  w[iy1][ix1]=w[iy2][ix2]=w[iy3][ix3]=w[iy4][ix4]=red;
//     sprintf(f2,"z%s",f1);  write_bmp(f2);
/* find qr 3 big eyes */
  eye(ix1,iy1,ix3,iy3, 1,1,&q1x,&q3x);
  eye(iy1,ix1,iy2,ix2, 1,0,&q1y,&q2y);
  eye(ix2,iy2,ix4,iy4,-1,1,&q2x,&q4x);
  eye(iy3,ix3,iy4,ix4,-1,0,&q3y,&q4y);
//  printf("%d_%d  %d_%d  %d_%d  %d_%d\n",q1x,q1y,q2x,q2y,q3x,q3y,q4x,q4y);
  k=false_eye(q1x,q1y,q2x,q2y,q3x,q3y,q4x,q4y);
    printf("f_eye: %d  ",k);
  if(k!=4){ turn_pic(k); goto l11; }

  u1=ix3-ix1; v1=iy3-iy1;  rx=sqrt(u1*u1+v1*v1);  k=q1x+q3x;  fx=14.*(rx-k)/k;
//  printf("%d %lf %lf\n",k,rx,fx);
  u2=ix2-ix1; v2=iy2-iy1;  ry=sqrt(u2*u2+v2*v2);  k=q1y+q2y;  fy=14.*(ry-k)/k;
//  printf("%d %lf %lf\n",k,ry,fy);

  r=(fx+fy-6.)*.125; qr=r+0.5;  k=qr*4+17;   nqr=k+4;
  sx=(rx+1)/k;  sy=(ry+1)/k;
 printf("%5.2lf QR%02d  %5.2lf %5.2lf\n",r,qr,sx,sy);
  th=atan2(u2-v1,u1+v2);  fx=sin(th);  fy=cos(th);

//expand w4 for display only
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)for(v=0;v<4;v++)for(u=0;u<4;u++)
  w4[j*4+v][i*4+u]=w[j][i];

//find eye_center
  if(qr<7){
    x=3.5; y=k-3.5;
    rx=x;  ry=x; all_eye(rx,ry,0,0);  //1   big_eye
    rx=x;  ry=y; all_eye(rx,ry,0,1);  //2   big_eye
    rx=y;  ry=x; all_eye(rx,ry,1,0);  //3   big_eye
           y=k-6.5;
    rx=y;  ry=y; all_eye(rx,ry,1,1);  //4
  } else {
    x=3.5; y=k-3.5;
    rx=x;  ry=x; all_eye(rx,ry,0,0);  //1
    rx=x;  ry=y; all_eye(rx,ry,0,2);  //2
    rx=y;  ry=x; all_eye(rx,ry,2,0);  //3
           y=k-6.5;
    rx=y;  ry=y; all_eye(rx,ry,2,2);  //4
    z=k*.5; x=6.5;
    rx=z;  ry=x; all_eye(rx,ry,1,0);
    rx=x;  ry=z; all_eye(rx,ry,0,1);
    rx=z;  ry=z; all_eye(rx,ry,1,1);
    rx=y;  ry=z; all_eye(rx,ry,2,1);
    rx=z;  ry=y; all_eye(rx,ry,1,2);
  }
  ne=2; if(qr>=7)ne=3;
  for(i=0;i<k;i++)xline[i]=yline[i]=0.;
  line2(ne,k);                       // get x,y AXIS_adjust;
  for(kx=0;kx<ne-1;kx++)for(ky=0;ky<ne-1;ky++){
    ix1=kx; ix2=ix1+2; iy1=ky; iy2=iy1+2; nn=0;
    for(i=ix1;i<ix2;i++)for(j=iy1;j<iy2;j++){
      ad[nn][0]=ekx[j][i]; ad[nn][1]=eky[j][i];
      xy[nn][0]=ex[j][i];  xy[nn][1]=ey[j][i];
      w9[nn]=ww[j][i];     nn++;
    }
    plate(xy,ad,w9,nn,a8);
//for(i=0;i<6;i++)printf("%lf ",a8[i]); printf("\n");
    for(i=0;i<nn;i++){
      x=a8[0]*ad[i][0]+a8[2]*ad[i][1]+a8[4];
      y=a8[1]*ad[i][0]+a8[3]*ad[i][1]+a8[5];
      z=sqrt((x-xy[i][0])*(x-xy[i][0])+(y-xy[i][1])*(y-xy[i][1]));
    }
//    printf("%7.2lf%7.2lf  %6.2lf%7.2lf==>%7.2lf%7.2lf +-:%6.4lf\n",
//                        xy[i][0],xy[i][1],ad[i][0],ad[i][1],x,y,z);
//  } printf("\n");
    if(ne==2){ ix3=iy3=0; ix4=iy4=k; }
    else {
      if(kx==0){ ix3=0; ix4=k/2; } else { ix3=k/2; ix4=k; }
      if(ky==0){ iy3=0; iy4=k/2; } else { iy3=k/2; iy4=k; }
    }
    for(j=iy3;j<iy4;j++)for(i=ix3;i<ix4;i++){
      tx=i+0.5;  ty=j+0.5;
      x=a8[0]*tx+a8[2]*ty+a8[4]   -xline[i];
      y=a8[1]*tx+a8[3]*ty+a8[5]   -yline[j];
      u=x*4;
      v=y*4;
      if(w4[v][u]!=red)w4[v][u]=green;
      d[j+2][i+2]=linear2(x,y);
    }
  }
       sprintf(f2,"z0%s",f1);  write_bmp4(f2);
       sprintf(f2,"z1%s",f1);  write_qr(f2);
  for(i=0;i<256;i++)hist[i]=0;
  for(j=2;j<nqr-2;j++)for(i=2;i<nqr-2;i++)hist[d[j][i]]++;
  k=l=0;
  for(i=0;i<256;i++){
    if(hist[i]==0)k++;
    else { if(j<k){ j=k; l=i; } k=0; }
  } l-=j/2;       printf("thr: %3d\n",l);
  if(l<wp)l=bw;
  for(j=0;j<nqr;j++)for(i=0;i<nqr;i++)d[j][i]=(d[j][i]>l)?255:0;
       sprintf(f2,"z2%s",f1);  write_hist(f2,0,l);
       sprintf(f2,"z3%s",f1);  write_qr(f2);

  goto l10;
l20:
  fclose(fp1);
}

all_eye(rx,ry,i,j)
double rx,ry;
{
  double tx,ty,x,y;
  int u,v;
  tx=rx*sx;           ty=ry*sy;
  x=tx*fy+ty*fx+ix1;  y=ty*fy-tx*fx+iy1;
  ww[j][i]=eye_center(x,y,&tx,&ty);
  u=tx*4;  v=ty*4.;   w4[v][u]=red;
  ekx[j][i]=rx; eky[j][i]=ry;
  ex[j][i]=tx;  ey[j][i]=ty;
}

eye_center(x,y,tx,ty)
double x,y, *tx,*ty;
{
  int i,j,k,ix,iy,i1,j1,k1,i0,j0,np=0;
  FILE *fp0;
  double r,s,t[31];
  unsigned char m[31][31];
  short hh[539];
  char ff[40];

  for(i=0;i<539;i++)hh[i]=h[i];
  hh[9]=hh[11]=31;
  ix=x+0.5;  iy=y+0.5;
//      printf("%3d%4d: ",ix,iy);
  for(j=0;j<31;j++)for(i=0;i<31;i++){
    u=ix-15+i; v=iy-15+j;  m[j][i]=0;
    if(u<0 || u>lw1)continue;
    if(v<0 || v>lh1)continue;
    m[j][i]=b[v][u];                  //if(m[j][i]<bw)m[j][i]=0;
  }
/*
  sprintf(ff,"z0%d%s",ii,f1);
  fp0=fopen(ff,"wb"); fwrite(hh,2,539,fp0);
  for(j1=0;j1<31;j1++){    k1=30-j1;
    for(i1=0;i1<31;i1++)c[i1]=255-m[k1][i1];
    fwrite(c,1,32,fp0);
  } fclose(fp0);
*/
// draw contours ==0
  j=15; k=255;
  for(i1=14;i1<31;i1++)if(m[j][i1]<k){ k=m[j][i1]; i=i1; }

// k==1; i--;    k=2; j--;  k=3;  i++;   k=4;  j++
  k=2;  i0=i; j0=j;
l30:
  if(i==i0 && j==j0 && np)goto l40;
  m[j][i]=green;
  np++;     if(np>99)goto l50;     // avoid dead loop
/*
if(ac==3){
  sprintf(ff,"zz%d%02d.bmp",ii,np);
  fp0=fopen(ff,"wb"); fwrite(hh,2,539,fp0);
  for(j1=0;j1<31;j1++){    k1=30-j1;
    for(i1=0;i1<31;i1++)c[i1]=255-m[k1][i1];
    fwrite(c,1,32,fp0);
  } fclose(fp0);
}
*/
  switch(k) {
l00:
case 1:    if(m[j+1][i]<=wp){ j++; k=4; goto l30; }
case 2:    if(m[j][i-1]<=wp){ i--; k=1; goto l30; }
case 3:    if(m[j-1][i]<=wp){ j--; k=2; goto l30; }
case 4:    if(m[j][i+1]<=wp){ i++; k=3; goto l30; }
           goto l00;
  }
l40:                                             // clear out parts
  for(j=0;j<31;j++){
    for(i=0;i<=15;i++)if(m[j][i]==green)break; else m[j][i]=0;
    for(i=30;i>15;i--)if(m[j][i]==green)break; else m[j][i]=0;
  }

  for(i=0;i<31;i++){ s=0.;    for(j=0;j<31;j++)s+=m[j][i]; t[i]=s;  }
  r=s=0; for(i=0;i<31;i++){ s+=t[i]*i; r+=t[i]; }
  s/=r;  // printf("%8.2lf ",s);
  *tx=ix+s-14.5;                                // X center

  for(j=0;j<31;j++){ s=0.;    for(i=0;i<31;i++)s+=m[j][i]; t[j]=s;  }
  r=s=0; for(j=0;j<31;j++){ s+=t[j]*j; r+=t[j]; }
  s/=r;  // printf("%8.2lf ",s);
  *ty=iy+s-14.5;                                // Y center
/*
  printf("%d ",np);
  sprintf(ff,"z1%d%s",ii,f1);
  fp0=fopen(ff,"wb"); fwrite(hh,2,539,fp0);
  m[15][15]=red;
  for(j1=0;j1<31;j1++){    k1=30-j1;
    for(i1=0;i1<31;i1++)c[i1]=255-m[k1][i1];
    fwrite(c,1,32,fp0);
  } fclose(fp0);
*/
  return(1);
l50:
  printf("no way!\n"); return(0);              // fail
}

int linear2(x,y)
double x,y;
{
  int ix0,iy0,ix1,iy1,k;
  double wx,wy,zx,zy,z0,z1,z2,z3;
// direct get result
  ix0=x; iy0=y;
  k=b[iy0][ix0];
  if(k>bp)return(255);
  if(k<wp)return(0);
// linear
  iy0=y; iy1=iy0+1; wy=y-iy0;   zy=1.-wy;
  ix0=x; ix1=ix0+1; wx=x-ix0;   zx=1.-wx;
  z0=zx*zy; z1=wx*zy; z2=zx*wy; z3=wx*wy;
  k=b[iy0][ix0]*z0+b[iy0][ix1]*z1+b[iy1][ix0]*z2+b[iy1][ix1]*z3;
  return (k);
}

turn_pic(int k)
{
  int i,j;
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)w[j][i]=b0[j][i];
  if(k==1)for(j=0;j<lh;j++)for(i=0;i<lw;i++)b0[lh1-j][lw1-i]=w[j][i];
  if(k==2)for(j=0;j<lh;j++)for(i=0;i<lw;i++)b0[i][lh1-j]    =w[j][i];
  if(k==3)for(j=0;j<lh;j++)for(i=0;i<lw;i++)b0[lw1-i][j]    =w[j][i];
  if(k>1){
    h[9]=lh;  h[11]=lw;
    lw=h[9];  lw1=lw-1;  lw0=(lw1/4+1)*4;
    lh=h[11]; lh1=lh-1;
  }
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)b[lh1-j][i]=255-b0[j][i];
}

false_eye(q1x,q1y,q2x,q2y,q3x,q3y,q4x,q4y)
int q1x,q1y,q2x,q2y,q3x,q3y,q4x,q4y;
{
  int i=1,j,k;
  k=q1x+q1y;
  j=q2x+q2y;  if(j<k){ k=j; i=2; }
  j=q3x+q3y;  if(j<k){ k=j; i=3; }
  j=q4x+q4y;  if(j<k){ k=j; i=4; }
  return(i);
}

eye(ix1,iy1,ix2,iy2,z,m,l1,l2)
int ix1,iy1,ix2,iy2,z,m,*l1,*l2;
{
  int i,j,k;
  double f;
  f=iy2-iy1; f/=(ix2-ix1); k=(ix2-ix1)/3;
  for(i=ix1+1;i<ix1+k;i++){
    j=iy1+f*(i-ix1)+0.5;
    if(m){ if(b[j][i]<bp && b[j+z][i]<bp)break; else continue; }
    else { if(b[i][j]<bp && b[i][j+z]<bp)break; else continue; }
  } *l1=i-ix1;
  for(i=ix2-1;i>ix2-k;i--){
    j=iy1+f*(i-ix1)+0.5;
    if(m){ if(b[j][i]<bp && b[j+z][i]<bp)break; else continue; }
    else { if(b[i][j]<bp && b[i][j+z]<bp)break; else continue; }
  } *l2=ix2-i;
}

de_edge4()
{
  int i,j;
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)  if(b[j][i]<wp)break; else b[j][i]=0;
  for(j=0;j<lh;j++)for(i=lw1;i>0;i--)if(b[j][i]<wp)break;  else b[j][i]=0;
  for(i=0;i<lw;i++)for(j=0;j<lh;j++)  if(b[j][i]<wp)break; else b[j][i]=0;
  for(i=0;i<lw;i++)for(j=lh1;j>0;j--)if(b[j][i]<wp)break;  else b[j][i]=0;
}

getbp_wp()
{
  int i,j,k;
  for(i=0;i<256;i++)hist[i]=0;
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)hist[b[j][i]]++;
  wp=k=0; for(i=0;  i< 50;i++)if(hist[i]>k){k=hist[i]; wp=i; }
  bp=255; k=0; for(i=216;i<256;i++)if(hist[i]>k){k=hist[i]; bp=i; }
}

read_bmp()
{
  int i,j,k;
  for(j=0;j<n2;j++)for(i=0;i<n1;i++)b0[j][i]=0;
//for(j=0;j<n2;j++)for(i=0;i<n1;i++)b[j][i]=0;
  f1[strlen(f1)-1]=0;  printf("%d: %s ",ip,f1);
  fp=fopen(f1,"rb"); if(fp==0){ printf("not found!\n"); return(1); }
  fread(h,2,539,fp);
  lh=h[11];  lh1=lh-1;
  lw=h[9];   lw1=lw-1;   lw0=(lw1/4 +1)*4;
  if(lw>n1 || lh >n2){ printf(" afraid, not a QR data\n"); return(1); }
  if(h[14]!=8) { printf(" not 8 bit BMP\n"); return(1); }
  for(j=0;j<lh;j++){
    fread(b0[j],1,lw0,fp);  k=lh1-j;
    for(i=0;i<lw;i++)b[k][i]=255-b0[j][i];
  }
  for(j=0;j<181;j++)for(i=0;i<181;i++)d[j][i]=0;
  h[535]=0x0000; h[536]=0xff;
  h[533]=0x00ff; h[534]=0x00;
  h[531]=0xff00; h[532]=0x00;
  return(0);
}

write_bmp4(char *ff)
{
  int i,j,k,lh,lh1,lw,lw1,lw0;   FILE *fp0;
  short hh[539];
  for(i=0;i<539;i++)hh[i]=h[i];
  lh=hh[11]; lh*=4; hh[11]=lh;  lh1=lh-1;
  lw=hh[9];  lw*=4;  hh[9]=lw;  lw1=lw-1; lw0=(lw1/4+1)*4;
  fp0=fopen(ff,"wb");     fwrite(hh,2,539,fp0);
  for(j=0;j<lh;j++){
    k=lh1-j;
    for(i=0;i<lw;i++)c[i]=255-w4[k][i];
    fwrite(c,1,lw0,fp0);
  }
  fclose(fp0);
}

write_bmp(char *ff)
{
  int i,j,k;   FILE *fp0;
  fp0=fopen(ff,"wb");     fwrite(h,2,539,fp0);
  for(j=0;j<lh;j++){ k=lh1-j;
    for(i=0;i<lw;i++)c[i]=255-w[k][i];
    fwrite(c,1,lw0,fp0);
  }
  fclose(fp0);
}

write_qr(char *ff)
{
  int i,j,k,lw0,lw1;   FILE *fp0;
  short hh[27];
  for(i=0;i<27;i++)hh[i]=h[i];
  hh[9]=hh[11]=nqr;  lw1=nqr-1;  lw0=(lw1/4+1)*4;
  k=nqr*nqr+0x436; hh[1]=k; hh[2]=k>>16;
  fp0=fopen(ff,"wb");     fwrite(hh,2,27,fp0);
  for(i=0;i<256;i++){ c[0]=c[1]=c[2]=i; c[3]=0; fwrite(c,1,4,fp0); }
  for(j=0;j<nqr;j++){ k=lw1-j;
    for(i=0;i<nqr;i++)c[i]=255-d[k][i];
    fwrite(c,1,lw0,fp0);
  }
  fclose(fp0);
}

unsigned char map[240][276];         // histogram map
write_hist(char *ff,int i220, int l)
{
  double y;
  int i,j,k;
  FILE *fp;
  k=hist[i220];  if(i220==0)k=qr*qr;
  y=200./k;
  for(i=0;i<256;i++)if(hist[i]>=k)hist[i]=200;  else hist[i]*=y;
  for(j=0;j<240;j++)for(i=0;i<276;i++)map[j][i]=0;
  for(i=0;i<256;i++)map[20+hist[i]][i+10]=255;
  if(i220){
    for(j=10;j<230;j++)map[j][bp+10]=bw;
    for(j=10;j<230;j++)map[j][wp+10]=bw;
  } else for(j=10;j<230;j++)map[j][l+10]=bw;
  h[9]=276; h[11]=240;
  fp=fopen(ff,"wb");
  fwrite(h,2,539,fp);    fwrite(map,276,240,fp); fclose(fp);
}

corner(u,v,x,y,zx,zy)                // input: u,v; output: x,y
int u,v,zx,zy, *x,*y;                // zx,zy  4 corner direction
{
  int i,j,k,r,s,t,p,q;
  k=bp;
  for(r=1;r<(lw+lh)/3;r++){
    for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
      s=u+i*zx; t=v+j*zy;
      if(s<0)s=0; if(s>lw1)s=lw1;
      if(t<0)t=0; if(t>lh1)t=lh1;
      if(b[t][s]>k){ k=b[t][s]; p=s; q=t; }
    }
    if(k!=bp)break;
  }
  *x=p;  *y=q;
}

de_noise()
{
  int i,j,k,m=0;
  for(j=0;j<lh;j++)for(i=0;i<lw;i++)w[j][i]=b[j][i];
  for(j=0;j<lh;j++)for(i=0;i<lw;i++){
    if(w[j][i]>bp || w[j][i]<wp )continue;
    k=0;
    if(w[j-2][i  ]<wp)k++;
    if(w[j-1][i-1]<wp)k++;
    if(w[j-1][i  ]<wp)k+=2;
    if(w[j-1][i+1]<wp)k++;
    if(w[j  ][i-2]<wp)k++;
    if(w[j  ][i-1]<wp)k+=2;
    if(w[j  ][i+1]<wp)k+=2;
    if(w[j  ][i+2]<wp)k++;
    if(w[j+1][i-1]<wp)k++;
    if(w[j+1][i  ]<wp)k+=2;
    if(w[j+1][i+1]<wp)k++;
    if(w[j+2][i  ]<wp)k++;
    if(k>11){ b[j][i]=0; m++;}                // delete white_noise, or color1
  }
//  printf("delete white_noise: %d\n",m);
}

plate(ad,xy,w,n,a8)
double ad[][2],xy[][2],a8[3][2]; int *w,n;
{
  double a[3][3],b[3],wk[3];
  int ixy,i,j,k;
  for(ixy=0;ixy<2;ixy++){
    for(j=0;j<3;j++){ b[j]=0.; for(i=0;i<3;i++)a[j][i]=0; }
    for(k=0;k<n;k++){
      if(w[k]){
        wk[0]=xy[k][0];    wk[1]=xy[k][1];    wk[2]=1.;
        for(j=0;j<3;j++){
          b[j]+=wk[j]*ad[k][ixy];
          for(i=0;i<3;i++)a[j][i]+=wk[i]*wk[j];
        }
      }
    }
    solve8(a,b);
    for(i=0;i<3;i++)a8[i][ixy]=b[i];
  }
}

solve8(a,b)
double a[3][3],b[3];
{
  double big,temp;  int i,j,k,l;
  for(i=0;i<2;i++){  big=0;
    for(k=i;k<3;k++){
      temp=a[i][k]; if(temp<0.)temp=-temp;
      if(temp > big){ big=temp; l=k; }
    }
    if(big==0.){ for(i=0;i<3;i++)b[i]=0.; return; }
    if(i!=l){
      for(j=0;j<3;j++){ temp=a[j][i]; a[j][i]=a[j][l]; a[j][l]=temp; }
      temp=b[i]; b[i]=b[l]; b[l]=temp;
    }
    for(j=i+1;j<3;j++){
      temp=a[i][j]/a[i][i];
      b[j]-=temp*b[i];
      for(k=i;k<3;k++)a[k][j]-=temp*a[k][i];
    }
  }
  for(i=0;i<3;i++){ l=2-i;
    if(a[l][l]==0.0){ b[l]=0.; continue; }
    temp=b[l];
    if(l!=2)for(j=1;j<=i;j++){ k=3-j; temp-=a[k][l]*b[k]; }
    b[l]=temp/a[l][l];
  }
}
